/*
 *  Copyright 2012 Anyware Services
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

Ext.namespace('org.ametys.cms.tool.iframe');

org.ametys.cms.tool.iframe.IframeTool = function(id, pluginName) 
{
	org.ametys.cms.tool.iframe.IframeTool.superclass.constructor.call(this, id, pluginName);
};

Ext.extend(org.ametys.cms.tool.iframe.IframeTool, org.ametys.uitool.tool.Tool);

org.ametys.cms.tool.iframe.IframeTool.prototype.createPanel = function()
{
	var url = this._configuration['url'];

	this.panel = new Ext.Panel ({
		tool : this,
		border: false,
		html: '',
		listeners: {
				'focus' : this._onFocus
		}
	});
	
	return this.panel;
}

org.ametys.cms.tool.iframe.IframeTool.prototype.setParams = function (params)
{
	this._title = params['title'] || this._configuration['title'];
	this._description = params['description'] || this._configuration['description'];
	this._iconSmall = params['icon-small'] || this._configuration['icon-small'];
	this._iconMedium = params['icon-medium'] || this._configuration['icon-medium'];
	this._iconLarge = params['icon-large'] || this._configuration['icon-large'];
	
	this._updateTooltip();
	this._repaintTooltip();
	
	this.panel.body.update ('<div style="width: 100%; height: 100%;">'
			+ '<iframe frameborder="0" style="width: 100%; height: 99%;" allowtransparency="true" src="' + params['url'] + '"></iframe>'
			+ '</div>');
}

/**
* Listener when the panel receives the focus
* Change the ribbon title and send a selection message
* @private
*/
org.ametys.cms.tool.iframe.IframeTool.prototype._onFocus = function ()
{
	var message = org.ametys.messagebus.bus.MessageBuilder.getInstance().createMessage(org.ametys.ribbon.RibbonManager.EVENTTYPE_SELECTIONCHANGED, null, []);
	org.ametys.messagebus.MessageBus.getInstance().fireMessages([message]);
}
